Index: cpukit/libmisc/monitor/mon-object.c
===================================================================
--- cpukit/libmisc/monitor/mon-object.c	(revision b06e68ef1f6df69cc86d72356c3a002054a35fad)
+++ cpukit/libmisc/monitor/mon-object.c	(revision b06e68ef1f6df69cc86d72356c3a002054a35fad)
@@ -0,0 +1,376 @@
+/*
+ *	@(#)object.c	1.7 - 95/08/02
+ *	
+ *
+ * RTEMS Monitor "object" support.
+ *
+ * Used to traverse object lists and print them out.
+ * An object can be an RTEMS object (chain based stuff) or
+ * a "misc" object such as a device driver.
+ *
+ * Each object has its own file in this directory (eg: extension.c)
+ * That file provides routines to convert a "native" structure
+ * to its canonical form, print a canonical structure, etc.
+ *
+ * TODO:
+ *     should allow for non-numeric id's???
+ *
+ *  $Id$
+ */
+
+#include <rtems.h>
+#include "monitor.h"
+
+#include <stdio.h>
+#include <stdlib.h>             /* strtoul() */
+
+#include <monitor.h>
+
+#define NUMELEMS(arr)	(sizeof(arr) / sizeof(arr[0]))
+
+/*
+ * add:
+ *     next
+ */
+
+rtems_monitor_object_info_t rtems_monitor_object_info[] =
+{
+    { RTEMS_OBJECT_CONFIG,
+      (void *) 0,
+      sizeof(rtems_monitor_config_t),
+      (rtems_monitor_object_next_fn)        rtems_monitor_config_next,
+      (rtems_monitor_object_canonical_fn)   rtems_monitor_config_canonical,
+      (rtems_monitor_object_dump_header_fn) rtems_monitor_config_dump_header,
+      (rtems_monitor_object_dump_fn)        rtems_monitor_config_dump,
+    },
+    { RTEMS_OBJECT_MPCI,
+      (void *) 0,
+      sizeof(rtems_monitor_mpci_t),
+      (rtems_monitor_object_next_fn)        rtems_monitor_mpci_next,
+      (rtems_monitor_object_canonical_fn)   rtems_monitor_mpci_canonical,
+      (rtems_monitor_object_dump_header_fn) rtems_monitor_mpci_dump_header,
+      (rtems_monitor_object_dump_fn)        rtems_monitor_mpci_dump,
+    },
+    { RTEMS_OBJECT_INIT_TASK,
+      (void *) 0,
+      sizeof(rtems_monitor_init_task_t),
+      (rtems_monitor_object_next_fn)        rtems_monitor_init_task_next,
+      (rtems_monitor_object_canonical_fn)   rtems_monitor_init_task_canonical,
+      (rtems_monitor_object_dump_header_fn) rtems_monitor_init_task_dump_header,
+      (rtems_monitor_object_dump_fn)        rtems_monitor_init_task_dump,
+    },
+    { RTEMS_OBJECT_TASK,
+      (void *) &_Thread_Information,
+      sizeof(rtems_monitor_task_t),
+      (rtems_monitor_object_next_fn)        rtems_monitor_manager_next,
+      (rtems_monitor_object_canonical_fn)   rtems_monitor_task_canonical,
+      (rtems_monitor_object_dump_header_fn) rtems_monitor_task_dump_header,
+      (rtems_monitor_object_dump_fn)        rtems_monitor_task_dump,
+    },
+    { RTEMS_OBJECT_QUEUE,
+      (void *) &_Message_queue_Information,
+      sizeof(rtems_monitor_queue_t),
+      (rtems_monitor_object_next_fn)        rtems_monitor_manager_next,
+      (rtems_monitor_object_canonical_fn)   rtems_monitor_queue_canonical,
+      (rtems_monitor_object_dump_header_fn) rtems_monitor_queue_dump_header,
+      (rtems_monitor_object_dump_fn)        rtems_monitor_queue_dump,
+    },
+    { RTEMS_OBJECT_EXTENSION,
+      (void *) &_Extension_Information,
+      sizeof(rtems_monitor_extension_t),
+      (rtems_monitor_object_next_fn)        rtems_monitor_manager_next,
+      (rtems_monitor_object_canonical_fn)   rtems_monitor_extension_canonical,
+      (rtems_monitor_object_dump_header_fn) rtems_monitor_extension_dump_header,
+      (rtems_monitor_object_dump_fn)        rtems_monitor_extension_dump,
+    },
+    { RTEMS_OBJECT_DRIVER,
+      (void *) 0,
+      sizeof(rtems_monitor_driver_t),
+      (rtems_monitor_object_next_fn)        rtems_monitor_driver_next,
+      (rtems_monitor_object_canonical_fn)   rtems_monitor_driver_canonical,
+      (rtems_monitor_object_dump_header_fn) rtems_monitor_driver_dump_header,
+      (rtems_monitor_object_dump_fn)        rtems_monitor_driver_dump,
+    },
+    { RTEMS_OBJECT_DNAME,
+      (void *) &rtems_driver_name_table[0],
+      sizeof(rtems_monitor_dname_t),
+      (rtems_monitor_object_next_fn)        rtems_monitor_dname_next,
+      (rtems_monitor_object_canonical_fn)   rtems_monitor_dname_canonical,
+      (rtems_monitor_object_dump_header_fn) rtems_monitor_dname_dump_header,
+      (rtems_monitor_object_dump_fn)        rtems_monitor_dname_dump,
+    },
+};
+
+/*
+ * Allow id's to be specified without the node number or
+ * type for convenience.
+ */
+
+rtems_id
+rtems_monitor_id_fixup(
+    rtems_id            id,
+    unsigned32          default_node,
+    rtems_object_type_t type
+)
+{
+    unsigned32  node;
+    
+    node = rtems_get_node(id);
+    if (node == 0)
+    {
+#if 0
+        /* XXX Uncomment this when types are added to id's */
+        if (rtems_get_type(id) != RTEMS_OBJECT_INVALID)
+            type = rtems_get_type(id);
+
+        id = _Objects_Build_id(type, default_node, rtems_get_index(id));
+#else
+        id = _Objects_Build_id(default_node, rtems_get_index(id));
+#endif
+    }
+    return id;
+}
+
+
+rtems_monitor_object_info_t *
+rtems_monitor_object_lookup(
+    rtems_object_type_t type
+)
+{
+    rtems_monitor_object_info_t *p;
+    for (p = &rtems_monitor_object_info[0];
+         p < &rtems_monitor_object_info[NUMELEMS(rtems_monitor_object_info)];
+         p++)
+    {
+        if (p->type == type)
+            return p;
+    }
+    return 0;
+}
+
+rtems_id
+rtems_monitor_object_canonical_next_remote(
+    rtems_object_type_t type,
+    rtems_id            id,
+    void               *canonical
+)
+{
+    rtems_id                        next_id;
+    rtems_status_code               status;
+    rtems_monitor_server_request_t  request;
+    rtems_monitor_server_response_t response;
+
+    /*
+     * Send request
+     */
+    
+    request.command = RTEMS_MONITOR_SERVER_CANONICAL;
+    request.argument0 = (unsigned32) type;
+    request.argument1 = (unsigned32) id;
+
+    status = rtems_monitor_server_request(rtems_get_node(id), &request, &response);
+    if (status != RTEMS_SUCCESSFUL)
+        goto failed;
+
+    /*
+     * process response
+     */
+    
+    next_id = (rtems_id) response.result0;
+    if (next_id != RTEMS_OBJECT_ID_FINAL)
+        (void) memcpy(canonical, &response.payload, response.result1);
+
+    return next_id;
+
+failed:
+    return RTEMS_OBJECT_ID_FINAL;
+
+}
+
+
+rtems_id
+rtems_monitor_object_canonical_next(
+    rtems_monitor_object_info_t *info,
+    rtems_id                     id,
+    void                        *canonical
+)
+{
+    rtems_id                     next_id;
+    void                        *raw_item;
+
+    if ( ! _Objects_Is_local_id(id))
+        next_id = rtems_monitor_object_canonical_next_remote(info->type,
+                                                             id,
+                                                             canonical);
+    else
+    {
+        next_id = id;
+        
+        raw_item = (void *) info->next(info->object_information,
+                                       canonical,
+                                       &next_id);
+
+        if (raw_item)
+        {
+            info->canonical(canonical, raw_item);
+            _Thread_Enable_dispatch();
+        }    
+    }    
+    return next_id;
+}
+
+
+/*
+ * this is routine server invokes locally to get the type
+ */
+
+rtems_id
+rtems_monitor_object_canonical_get(
+    rtems_object_type_t  type,
+    rtems_id             id,
+    void                *canonical,
+    unsigned32          *size_p
+)
+{
+    rtems_monitor_object_info_t *info;
+    rtems_id                     next_id;
+
+    *size_p = 0;
+
+    info = rtems_monitor_object_lookup(type);
+
+    if (info == 0)
+        return RTEMS_OBJECT_ID_FINAL;
+
+    next_id = rtems_monitor_object_canonical_next(info, id, canonical);
+    *size_p = info->size;
+
+    return next_id;
+}
+
+
+void
+rtems_monitor_object_dump_1(
+    rtems_monitor_object_info_t *info,
+    rtems_id                     id,
+    boolean                      verbose
+)
+{
+    rtems_id next_id;
+    rtems_monitor_union_t canonical;
+
+    if ((next_id = rtems_monitor_object_canonical_next(
+                                     info,
+                                     id,
+                                     &canonical)) != RTEMS_OBJECT_ID_FINAL)
+    {
+        /*
+         * If the one we actually got is the one we wanted, then
+         * print it out.
+         * For ones that have an id field, this works fine,
+         * for all others, always dump it out.
+         *
+         * HACK: the way we determine whether there is an id is a hack.
+         *
+         * by the way: the reason we try to not have an id, is that some
+         *   of the canonical structures are almost too big for shared
+         *   memory driver (eg: mpci)
+         */
+        
+        if ((info->next != rtems_monitor_manager_next) ||
+            (id == canonical.generic.id))
+            info->dump(&canonical, verbose);
+    }
+}
+
+void
+rtems_monitor_object_dump_all(
+    rtems_monitor_object_info_t *info,
+    boolean                      verbose
+)
+{
+    rtems_id next_id;
+    rtems_monitor_union_t canonical;
+
+    next_id = RTEMS_OBJECT_ID_INITIAL(rtems_monitor_default_node);
+
+    while ((next_id = rtems_monitor_object_canonical_next(
+                                         info,
+                                         next_id,
+                                         &canonical)) != RTEMS_OBJECT_ID_FINAL)
+    {
+        info->dump(&canonical, verbose);
+    }
+}
+
+void
+rtems_monitor_object_cmd(
+    int        argc,
+    char     **argv,
+    unsigned32 command_arg,
+    boolean    verbose
+)
+{
+    int arg;
+    rtems_monitor_object_info_t *info = 0;
+    rtems_object_type_t          type = (rtems_object_type_t) command_arg;
+    
+    /* what is the default type? */
+    type = (rtems_object_type_t) command_arg;
+
+    if (argc == 1)
+    {
+        if (type == RTEMS_OBJECT_INVALID)
+        {
+            printf("A type must be specified to \"dump all\"\n");
+            goto done;
+        }
+        
+        info = rtems_monitor_object_lookup(type);
+        if (info == 0)
+            goto not_found;
+
+        if (info->dump_header)
+            info->dump_header(verbose);
+        rtems_monitor_object_dump_all(info, verbose);
+    }
+    else
+    {
+        unsigned32          default_node = rtems_monitor_default_node;
+        rtems_object_type_t last_type = RTEMS_OBJECT_INVALID;
+        rtems_id            id;
+
+        for (arg=1; argv[arg]; arg++)
+        {
+            id = (rtems_id) strtoul(argv[arg], 0, 0);
+            id = rtems_monitor_id_fixup(id, default_node, type);
+#if 0
+            type = rtems_get_type(id);
+#endif
+            /*
+             * Allow the item type to change in the middle
+             * of the command.  If the type changes, then
+             * just dump out a new header and keep on going.
+             */
+            if (type != last_type)
+            {
+                info = rtems_monitor_object_lookup(type);
+                if (info == 0)
+                {
+not_found:          printf("Invalid or unsupported type %d\n", type);
+                    goto done;
+                }
+            
+                if (info->dump_header)
+                    info->dump_header(verbose);
+            }
+
+            rtems_monitor_object_dump_1(info, id, verbose);
+
+            default_node = rtems_get_node(id);
+            
+            last_type = type;
+        }
+    }
+done:
+}
Index: cpukit/libmisc/monitor/mon-prmisc.c
===================================================================
--- cpukit/libmisc/monitor/mon-prmisc.c	(revision b06e68ef1f6df69cc86d72356c3a002054a35fad)
+++ cpukit/libmisc/monitor/mon-prmisc.c	(revision b06e68ef1f6df69cc86d72356c3a002054a35fad)
@@ -0,0 +1,257 @@
+/*
+ *	@(#)prmisc.c	1.9 - 95/08/02
+ *	
+ *
+ * Print misc stuff for the monitor dump routines
+ * Each routine returns the number of characters it output.
+ *
+ * TODO:
+ *
+ *  $Id$
+ */
+
+#include <rtems.h>
+#include "monitor.h"
+
+#include <rtems/assoc.h>
+
+#include <stdio.h>
+#include <ctype.h>
+
+void
+rtems_monitor_separator(void)
+{
+    printf("------------------------------------------------------------------------------\n");
+}
+
+unsigned32
+rtems_monitor_pad(
+    unsigned32  destination_column,
+    unsigned32  current_column
+)
+{
+    int pad_length;
+    
+    if (destination_column <= current_column)
+        pad_length = 1;
+    else
+        pad_length = destination_column - current_column;
+
+    return printf("%*s", pad_length, "");
+}
+
+unsigned32
+rtems_monitor_dump_char(rtems_unsigned8 ch)
+{
+    if (isprint(ch))
+        return printf("%c", ch);
+    else
+        return printf("%02x", ch);
+}
+
+unsigned32
+rtems_monitor_dump_decimal(unsigned32 num)
+{
+    return printf("%4d", num);
+}
+
+unsigned32
+rtems_monitor_dump_hex(unsigned32 num)
+{
+    return printf("0x%x", num);
+}
+
+unsigned32
+rtems_monitor_dump_assoc_bitfield(
+    rtems_assoc_t *ap,
+    char          *separator,
+    unsigned32     value
+  )
+{  
+    unsigned32 b;
+    unsigned32 length = 0;
+    char *name;
+
+    for (b = 1; b; b <<= 1)
+        if (b & value)
+        {
+            if (length)
+                length += printf("%s", separator);
+
+            name = rtems_assoc_name_by_local(ap, b);
+            
+            if (name)
+                length += printf("%s", name);
+            else
+                length += printf("0x%x", b);
+        }
+        
+    return length;
+}
+
+unsigned32
+rtems_monitor_dump_id(rtems_id id)
+{
+    return printf("%08x", id);
+}
+
+unsigned32
+rtems_monitor_dump_name(rtems_name name)
+{
+    int i;
+    unsigned32 length = 0;
+    union {
+        unsigned32 ui;
+        char       c[4];
+    } u;
+    
+    u.ui = (rtems_unsigned32) name;
+    
+    for (i=0; i<sizeof(u.c); i++)
+        length += rtems_monitor_dump_char(u.c[i]);
+    return length;
+}
+
+unsigned32
+rtems_monitor_dump_priority(rtems_task_priority priority)
+{
+    return printf("%3d", priority);
+}
+
+
+rtems_assoc_t rtems_monitor_state_assoc[] = {
+    { "DORM",   STATES_DORMANT },
+    { "SUSP",   STATES_SUSPENDED },
+    { "TRANS",  STATES_TRANSIENT },
+    { "DELAY",  STATES_DELAYING },
+    { "Wbuf",   STATES_WAITING_FOR_BUFFER },
+    { "Wseg",   STATES_WAITING_FOR_SEGMENT },
+    { "Wmsg" ,  STATES_WAITING_FOR_MESSAGE },
+    { "Wevnt",  STATES_WAITING_FOR_EVENT },
+    { "Wsem",   STATES_WAITING_FOR_SEMAPHORE },
+    { "Wtime",  STATES_WAITING_FOR_TIME },
+    { "Wrpc",   STATES_WAITING_FOR_RPC_REPLY },
+    { "WRATE",  STATES_WAITING_FOR_PERIOD },
+    { 0, 0, 0 },
+};
+
+unsigned32
+rtems_monitor_dump_state(States_Control state)
+{
+    unsigned32 length = 0;
+
+    if (state == STATES_READY)  /* assoc doesn't deal with this as it is 0 */
+        length += printf("READY");
+    
+    length += rtems_monitor_dump_assoc_bitfield(rtems_monitor_state_assoc,
+                                                ":",
+                                                state);
+    return length;
+}
+
+rtems_assoc_t rtems_monitor_attribute_assoc[] = {
+    { "FL",  RTEMS_FLOATING_POINT },
+    { "GL",  RTEMS_GLOBAL },
+    { "PR",  RTEMS_PRIORITY },
+    { "BI",  RTEMS_BINARY_SEMAPHORE },
+    { "IN",  RTEMS_INHERIT_PRIORITY },
+    { 0, 0, 0 },
+};
+
+unsigned32
+rtems_monitor_dump_attributes(rtems_attribute attributes)
+{
+    unsigned32 length = 0;
+
+    if (attributes == RTEMS_DEFAULT_ATTRIBUTES)  /* value is 0 */
+        length += printf("DEFAULT");
+    
+    length += rtems_monitor_dump_assoc_bitfield(rtems_monitor_attribute_assoc,
+                                                ":",
+                                                attributes);
+    return length;
+}
+
+rtems_assoc_t rtems_monitor_modes_assoc[] = {
+    { "nP",     RTEMS_NO_PREEMPT },
+    { "T",      RTEMS_TIMESLICE },
+    { "nA",     RTEMS_NO_ASR },
+    { 0, 0, 0 },
+};
+
+unsigned32
+rtems_monitor_dump_modes(rtems_mode modes)
+{
+    unsigned32 length = 0;
+
+    if (modes == RTEMS_DEFAULT_MODES)  /* value is 0 */
+        length += printf("P:T:nA");
+    
+    length += rtems_monitor_dump_assoc_bitfield(rtems_monitor_modes_assoc,
+                                                ":",
+                                                modes);
+    return length;
+}
+
+rtems_assoc_t rtems_monitor_events_assoc[] = {
+    { "0",   RTEMS_EVENT_0 },
+    { "1",   RTEMS_EVENT_1 },
+    { "2",   RTEMS_EVENT_2 },
+    { "3",   RTEMS_EVENT_3 },
+    { "4",   RTEMS_EVENT_4 },
+    { "5",   RTEMS_EVENT_5 },
+    { "6",   RTEMS_EVENT_6 },
+    { "7",   RTEMS_EVENT_7 },
+    { "8",   RTEMS_EVENT_8 },
+    { "9",   RTEMS_EVENT_9 },
+    { "10",  RTEMS_EVENT_10 },
+    { "11",  RTEMS_EVENT_11 },
+    { "12",  RTEMS_EVENT_12 },
+    { "13",  RTEMS_EVENT_13 },
+    { "14",  RTEMS_EVENT_14 },
+    { "15",  RTEMS_EVENT_15 },
+    { "16",  RTEMS_EVENT_16 },
+    { "17",  RTEMS_EVENT_17 },
+    { "18",  RTEMS_EVENT_18 },
+    { "19",  RTEMS_EVENT_19 },
+    { "20",  RTEMS_EVENT_20 },
+    { "21",  RTEMS_EVENT_21 },
+    { "22",  RTEMS_EVENT_22 },
+    { "23",  RTEMS_EVENT_23 },
+    { "24",  RTEMS_EVENT_24 },
+    { "25",  RTEMS_EVENT_25 },
+    { "26",  RTEMS_EVENT_26 },
+    { "27",  RTEMS_EVENT_27 },
+    { "28",  RTEMS_EVENT_28 },
+    { "29",  RTEMS_EVENT_29 },
+    { "30",  RTEMS_EVENT_30 },
+    { "31",  RTEMS_EVENT_31 },
+    { 0, 0, 0 },
+};
+
+unsigned32
+rtems_monitor_dump_events(rtems_event_set events)
+{
+    unsigned32 length = 0;
+
+    if (events == EVENT_SETS_NONE_PENDING)  /* value is 0 */
+        length += printf("NONE");
+    
+    length += rtems_monitor_dump_assoc_bitfield(rtems_monitor_events_assoc,
+                                                ":",
+                                                events);
+    return length;
+}
+
+unsigned32
+rtems_monitor_dump_notepad(unsigned32 *notepad)
+{
+    unsigned32 length = 0;
+    int i;
+
+    for (i=0; i < RTEMS_NUMBER_NOTEPADS; i++)
+        if (notepad[i])
+            length += printf("%d: 0x%x ", i, notepad[i]);
+
+    return length;
+}
Index: cpukit/libmisc/monitor/mon-queue.c
===================================================================
--- cpukit/libmisc/monitor/mon-queue.c	(revision b06e68ef1f6df69cc86d72356c3a002054a35fad)
+++ cpukit/libmisc/monitor/mon-queue.c	(revision b06e68ef1f6df69cc86d72356c3a002054a35fad)
@@ -0,0 +1,66 @@
+/*
+ *	@(#)queue.c	1.5 - 95/07/31
+ *	
+ *  $Id$
+ */
+
+#include <rtems.h>
+#include "monitor.h"
+
+#include <stdio.h>
+
+void
+rtems_monitor_queue_canonical(
+    rtems_monitor_queue_t *canonical_queue,
+    void                  *queue_void
+)
+{
+    Message_queue_Control *rtems_queue = (Message_queue_Control *) queue_void;
+
+    canonical_queue->attributes = rtems_queue->attribute_set;
+    canonical_queue->maximum_message_size = rtems_queue->maximum_message_size;
+    canonical_queue->maximum_pending_messages = rtems_queue->maximum_pending_messages;
+    canonical_queue->number_of_pending_messages = rtems_queue->number_of_pending_messages;
+}
+
+void
+rtems_monitor_queue_dump_header(
+    boolean verbose
+)
+{
+    printf("\
+  ID       NAME   ATTRIBUTES   PEND   MAXPEND  MAXSIZE\n");
+/*23456789 123456789 123456789 123456789 123456789 123456789 123456789 123456789
+0         1         2         3         4         5         6         7       */
+    rtems_monitor_separator();
+}
+
+
+/*
+ * Dump out the "next" queue indicated by 'id'.
+ * Returns next one to check.
+ * Returns RTEMS_OBJECT_ID_FINAL when all done
+ */
+
+void
+rtems_monitor_queue_dump(
+    rtems_monitor_queue_t *monitor_queue,
+    boolean  verbose
+)
+{
+    unsigned32            length = 0;
+
+    length += rtems_monitor_dump_id(monitor_queue->id);
+    length += rtems_monitor_pad(11, length);
+    length += rtems_monitor_dump_name(monitor_queue->name);
+    length += rtems_monitor_pad(19, length);
+    length += rtems_monitor_dump_attributes(monitor_queue->attributes);
+    length += rtems_monitor_pad(31, length);
+    length += rtems_monitor_dump_decimal(monitor_queue->number_of_pending_messages);
+    length += rtems_monitor_pad(39, length);
+    length += rtems_monitor_dump_decimal(monitor_queue->maximum_pending_messages);
+    length += rtems_monitor_pad(48, length);
+    length += rtems_monitor_dump_decimal(monitor_queue->maximum_message_size);
+
+    printf("\n");
+}
Index: cpukit/libmisc/monitor/mon-server.c
===================================================================
--- cpukit/libmisc/monitor/mon-server.c	(revision b06e68ef1f6df69cc86d72356c3a002054a35fad)
+++ cpukit/libmisc/monitor/mon-server.c	(revision b06e68ef1f6df69cc86d72356c3a002054a35fad)
@@ -0,0 +1,305 @@
+/*
+ *	@(#)server.c	1.3 - 95/08/02
+ *	
+ *
+ * RTEMS monitor server (handles requests for info from RTEMS monitors
+ *             running on other nodes)
+ *
+ *  $Id$
+ */
+
+#include <rtems.h>
+
+#include <stdio.h>
+#include <string.h>
+#include <stdlib.h>
+#include <unistd.h>
+
+#include "monitor.h"
+
+/*
+ * Various id's for the server
+ */
+
+rtems_id  rtems_monitor_server_task_id;
+rtems_id  rtems_monitor_server_request_queue_id;	/* our server */
+rtems_id *rtems_monitor_server_request_queue_ids;       /* all servers */
+rtems_id  rtems_monitor_server_response_queue_id;       /* our server */
+
+
+/*
+ * Send a request to a server task
+ */
+
+rtems_status_code
+rtems_monitor_server_request(
+    unsigned32                       server_node,
+    rtems_monitor_server_request_t  *request,
+    rtems_monitor_server_response_t *response
+)
+{
+    rtems_id          server_id;
+    rtems_status_code status;
+    unsigned32        size;
+
+    /*
+     * What is id of monitor on target node?
+     * Look it up if we don't know it yet.
+     */
+    
+    server_id = rtems_monitor_server_request_queue_ids[server_node];
+    if (server_id == 0)
+    {
+        status = rtems_message_queue_ident(RTEMS_MONITOR_QUEUE_NAME,
+                                           server_node,
+                                           &server_id);
+        if (status != RTEMS_SUCCESSFUL)
+        {
+            rtems_error(status, "ident of remote server failed");
+            goto done;
+        }
+        
+        rtems_monitor_server_request_queue_ids[server_node] = server_id;
+    }
+
+    request->return_id = rtems_monitor_server_response_queue_id;
+
+    status = rtems_message_queue_send(server_id, request, sizeof(*request));
+    if (status != RTEMS_SUCCESSFUL)
+    {
+        rtems_error(status, "monitor server request send failed");
+        goto done;
+    }
+    
+    /*
+     * Await response, if requested
+     */
+
+    if (response)
+    {
+        status = rtems_message_queue_receive(rtems_monitor_server_response_queue_id,
+                                             response,
+                                             &size,
+                                             RTEMS_WAIT,
+                                             100);
+        if (status != RTEMS_SUCCESSFUL)
+        {
+            rtems_error(status, "server did not respond");
+
+            /* maybe server task was restarted; look it up again next time */
+            rtems_monitor_server_request_queue_ids[server_node] = 0;
+
+            goto done;
+        }
+
+        if (response->command != RTEMS_MONITOR_SERVER_RESPONSE)
+        {
+            status = RTEMS_INCORRECT_STATE;
+            goto done;
+        }            
+    }
+    
+done:
+    return status;
+}
+
+
+
+/*
+ * monitor server task
+ */
+
+void
+rtems_monitor_server_task(
+    rtems_task_argument monitor_flags
+)
+{
+    rtems_monitor_server_request_t  request;
+    rtems_monitor_server_response_t response;
+    rtems_status_code               status;
+    unsigned32                      size;
+
+    for (;;)
+    {
+        status = rtems_message_queue_receive(
+                        rtems_monitor_server_request_queue_id,
+                        &request,
+                        &size,
+                        RTEMS_WAIT,
+                        (rtems_interval) 0);
+
+        if (status != RTEMS_SUCCESSFUL)
+        {
+            rtems_error(status, "monitor server msg queue receive error");
+            goto failed;
+        }
+                                             
+        if (size != sizeof(request))
+        {
+            rtems_error(0, "monitor server bad size on receive");
+            goto failed;
+        }
+        
+        switch (request.command)
+        {
+            case RTEMS_MONITOR_SERVER_CANONICAL:
+            {
+                rtems_object_type_t object_type;
+                rtems_id            id;
+                rtems_id            next_id;
+
+                object_type = (rtems_object_type_t) request.argument0;
+                id          = (rtems_id)            request.argument1;
+                next_id = rtems_monitor_object_canonical_get(object_type,
+                                                             id,
+                                                             &response.payload,
+                                                             &size);
+
+                response.command = RTEMS_MONITOR_SERVER_RESPONSE;
+                response.result0 = next_id;
+                response.result1 = size;
+
+#define SERVER_OVERHEAD  (RTEMS_offsetof(rtems_monitor_server_response_t, \
+                                         payload))
+                    
+                status = rtems_message_queue_send(request.return_id,
+                                                  &response,
+                                                  size + SERVER_OVERHEAD);
+                if (status != RTEMS_SUCCESSFUL)
+                {
+                    rtems_error(status, "response send failed");
+                    goto failed;
+                }
+                break;
+            }
+
+            default:
+            {
+                rtems_error(0, "invalid command to monitor server: %d", request.command);
+                goto failed;
+            }
+        }
+    }
+
+failed:
+    rtems_task_delete(RTEMS_SELF);
+}
+
+    
+/*
+ * Kill off any old server
+ * Not sure if this is useful, but it doesn't help
+ */
+
+void
+rtems_monitor_server_kill(void)
+{
+    if (rtems_monitor_server_task_id)
+        rtems_task_delete(rtems_monitor_server_task_id);
+    rtems_monitor_task_id = 0;
+
+    if (rtems_monitor_server_request_queue_id)
+        rtems_message_queue_delete(rtems_monitor_server_request_queue_id);
+    rtems_monitor_server_response_queue_id = 0;
+
+    if (rtems_monitor_server_response_queue_id)
+        rtems_message_queue_delete(rtems_monitor_server_response_queue_id);
+    rtems_monitor_server_request_queue_ids = 0;
+
+    if (rtems_monitor_server_request_queue_ids)
+        free(rtems_monitor_server_request_queue_ids);
+    rtems_monitor_server_request_queue_ids = 0;
+}
+
+
+void
+rtems_monitor_server_init(
+    unsigned32 monitor_flags
+)
+{
+    rtems_status_code status;
+    
+    if (_Configuration_Is_multiprocessing()    &&
+        (_Configuration_MP_table->maximum_nodes > 1))
+    {
+        unsigned32 maximum_nodes = _Configuration_MP_table->maximum_nodes;
+        
+        /*
+         * create the msg que our server will listen
+         * Since we only get msgs from other RTEMS monitors, we just
+         * need reserve space for 1 msg from each node.
+         */
+
+        status = rtems_message_queue_create(
+                       RTEMS_MONITOR_QUEUE_NAME,
+                       maximum_nodes,
+                       sizeof(rtems_monitor_server_request_t),
+                       RTEMS_GLOBAL,
+                       &rtems_monitor_server_request_queue_id);
+        
+        if (status != RTEMS_SUCCESSFUL)
+        {
+            rtems_error(status, "could not create monitor server message queue");
+            goto done;
+        }
+          
+        /*
+         * create the msg que our responses will come on
+         * Since monitor just does one thing at a time, we only need 1 item
+         * message queue.
+         */
+        
+        status = rtems_message_queue_create(
+                       RTEMS_MONITOR_RESPONSE_QUEUE_NAME,
+                       1, /* depth */
+                       sizeof(rtems_monitor_server_response_t),
+                       RTEMS_GLOBAL,
+                       &rtems_monitor_server_response_queue_id);
+        
+        if (status != RTEMS_SUCCESSFUL)
+        {
+            rtems_error(status, "could not create monitor response message queue");
+            goto done;
+        }
+          
+        /* need an id for queue of each other server we might talk to */
+        /* indexed by node, so add 1 to maximum_nodes */
+        rtems_monitor_server_request_queue_ids =
+                   (rtems_id *) malloc((maximum_nodes + 1) * sizeof(rtems_id));
+        (void) memset(rtems_monitor_server_request_queue_ids,
+                      0,
+                      (maximum_nodes + 1) * sizeof(rtems_id));
+
+        rtems_monitor_server_request_queue_ids[rtems_monitor_node] =
+                   rtems_monitor_server_request_queue_id;
+
+        /*
+         * create the server task
+         */
+        status = rtems_task_create(RTEMS_MONITOR_SERVER_NAME,
+                                   1,
+                                   0 /* default stack */,
+                                   RTEMS_INTERRUPT_LEVEL(0),
+                                   RTEMS_DEFAULT_ATTRIBUTES,
+                                   &rtems_monitor_server_task_id);
+        if (status != RTEMS_SUCCESSFUL)
+        {
+            rtems_error(status, "could not create monitor server task");
+            goto done;
+        }
+
+        /*
+         * Start the server task
+         */
+        status = rtems_task_start(rtems_monitor_server_task_id,
+                                  rtems_monitor_server_task,
+                                  monitor_flags);
+        if (status != RTEMS_SUCCESSFUL)
+        {
+            rtems_error(status, "could not start monitor server");
+            goto done;
+        }
+    }
+
+done:
+}
